package org.naokishibata.examples;

import org.naokishibata.generic.*;
import org.naokishibata.ocvimgio.*;

public class BGVideoWriter implements Runnable {
    final Thread th;
    final CvVideoWriter vw;

    IplImage iimg = null;
    boolean exiting = false, closed = false;

    public BGVideoWriter(String fn, String fourcc, double fps, int width, int height, int is_color) {
	vw = CvVideoWriter.cvCreateVideoWriter(fn, fourcc, fps, width, height, is_color);
	th = new Thread(this);
	th.start();
    }

    public static BGVideoWriter cvCreateVideoWriter(String fn, String fourcc, double fps, int width, int height, int is_color) {
	return new BGVideoWriter(fn, fourcc, fps, width, height, is_color);
    }

    public void run() {
	synchronized(this) {
	    for(;;) {
		while(iimg == null && exiting == false) {
		    try { wait(); } catch(InterruptedException ex) {}
		}

		if (exiting) break;

		if (iimg == null) continue;

		vw.cvWriteFrame(iimg);
		iimg = null;
		notifyAll();
	    }

	    vw.close();
	    closed = true;
	    notifyAll();
	}
    }

    public void cvWriteFrame(IplImage img) {
	synchronized(this) {
	    if (exiting) return;

	    while(iimg != null) {
		try { wait(); } catch(InterruptedException ex) {}
	    }

	    iimg = img;
	    notifyAll();
	}
    }

    public void close() {
	synchronized(this) {
	    exiting = true;
	    notifyAll();

	    while(closed != true) {
		try { wait(); } catch(InterruptedException ex) {}
	    }
	}
    }
}
