package org.naokishibata.math;

import java.io.*;
import org.naokishibata.generic.*;

/**
   VectorN represents a vector
 */
public class VectorN extends Matrix {
    public VectorN(double ... x) {
	super(x.length, 1);
	for(int i=0;i<x.length;i++) {
	    a[i] = x[i];
	}
    }

    public VectorN(Matrix v) {
	super(v.m, 1);
	assert v.n == 1;
	for(int i=0;i<v.m;i++) {
	    a[i] = v.a[i];
	}
    }

    public double v(int y) {
	return a[y];
    }

    public double dot(VectorN v) {
	double ret = 0;
	for(int i=0;i<v.n;i++) {
	    ret += a[i] * v.a[i];
	}

	return ret;
    }

    /*
    public double dot(Matrix m) {
	assert(m.m == 1 && m.n == this.m);

	double ret = 0;
	for(int i=0;i<m.n;i++) {
	    ret += a[i] * m.a[i];
	}

	return ret;
    }
    */

    public VectorN times(double v) {
	double[] x = new double[m];

	for(int i=0;i<m;i++) x[i] = a[i] * v;

	return new VectorN(x);
    }

    public VectorN dot(double v) {
	return this.times(v);
    }

    public VectorN plus(Matrix m) {
	assert(m.m == this.m && m.n == 1);

	double[] x = new double[this.m];

	for(int i=0;i<this.m;i++) x[i] = a[i] + m.a[i];

	return new VectorN(x);
    }

    public VectorN minus(Matrix m) {
	assert(m.m == this.m && m.n == 1);

	double[] x = new double[this.m];

	for(int i=0;i<this.m;i++) x[i] = a[i] - m.a[i];

	return new VectorN(x);
    }

    public double length() {
	double n = 0;

	for(int i=0;i<this.m;i++) n += a[i] * a[i];

	return Math.sqrt(n);
    }

    public VectorN normalized() {
	return this.dot(1.0 / this.length());
    }
}
